//
//  QAAppDelegate.h
//  SceneKit Demo
//
//  Created by Daniel Dönigus on 08.11.12.
//  Copyright (c) 2012 Quality Applications. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import <SceneKit/SceneKit.h>

@interface QAAppDelegate : NSObject <NSApplicationDelegate>

@property (assign) IBOutlet id selectedInsertGeometry;
@property (retain) IBOutlet NSArray* creatableObjects;
@property (retain) SCNNode* spotLightNode;
@property (assign) IBOutlet SCNView* sceneView;
@property (assign) IBOutlet SCNScene* scene;
@property (assign) IBOutlet NSWindow* window;
@property (assign) IBOutlet NSNumber* selectedObjectIndex;
@property (retain) NSMutableArray* nodes;
@property (retain) SCNNode* selectedNode;
@property (retain) CAAnimationGroup* fadeOutAnimation;
@property (retain) NSMutableArray* removedNodes;
@property (retain) CAAnimationGroup* insertAnimation;

@property (retain) SCNNode* textureWoodNode;
@property (retain) SCNNode* textureJeansNode;
@property (retain) SCNNode* textureEarthNode;
@property (retain) SCNNode* selectedMaterialNode;

@property (retain) SCNNode* materialRedMatteNode;
@property (retain) SCNNode* materialBlueGlossyNode;
@property (retain) SCNNode* materialWhiteMatteNode;

- (IBAction)insertAdditionalObject:(id)sender;
- (IBAction)removeSelectedObject:(id)sender;

- (IBAction)redMatte:(id)sender;
- (IBAction)blueGlossy:(id)sender;
- (IBAction)whiteMatte:(id)sender;

- (IBAction)textureWood:(id)sender;
- (IBAction)textureJeans:(id)sender;
- (IBAction)textureEarth:(id)sender;

- (void) leftPressed;
- (void) rightPressed;

- (void) mousePressedAtPoint:(CGPoint) point;

@end
