//
//  QAPaintingView.m
//  TexturePainting
//
//  Created by Daniel Dönigus on 14.10.12.
//  Copyright (c) 2012 Quality Applications. All rights reserved.
//

#import "QAPaintingView.h"
#import "QAAppDelegate.h"

@implementation QAPaintingView

- (void) awakeFromNib {
    QAAppDelegate* delegate = [[NSApplication sharedApplication] delegate];
    
    //Making this view a layer backed view
    CALayer* layer = [CALayer layer];
    layer.delegate = delegate;
    [layer setBackgroundColor:[[NSColor whiteColor] CGColor]];
    self.wantsLayer = YES;
    
    self.layer = layer;
    delegate.viewLayer = layer;
}

- (void)mouseDown:(NSEvent *)theEvent {
    QAAppDelegate* delegate = [[NSApplication sharedApplication] delegate];
    
    //Retrieving the mouse position scaled to 0-1
    CGPoint pointInView = [self convertPoint:[theEvent locationInWindow] fromView:nil];
    pointInView.x = pointInView.x/self.layer.bounds.size.width;
    pointInView.y = pointInView.y/self.layer.bounds.size.height;

    //Creating an additional geometry
    [delegate drawingStartedAtPosition:pointInView];
}

- (void)mouseUp:(NSEvent *)theEvent {
    QAAppDelegate* delegate = [[NSApplication sharedApplication] delegate];
    
    //finalizing the geometry -> adding to array of geometries
    [delegate finalizeGeometry];
}

- (void)mouseDragged:(NSEvent *)theEvent {
    QAAppDelegate* delegate = [[NSApplication sharedApplication] delegate];
    
    //Retrieving the mouse position scaled to 0-1
    CGPoint pointInView = [self convertPoint:[theEvent locationInWindow] fromView:nil];
    pointInView.x = pointInView.x/self.layer.bounds.size.width;
    pointInView.y = pointInView.y/self.layer.bounds.size.height;
    
    //Adding a new point to current drawing geometry
    [delegate addAdditionalPointAtPosition:pointInView];
}

@end
